<nz-table
  class="data-table"
  [nzShowPagination]="tableConfig.showPagination == null ? true : tableConfig.showPagination"
  nzTableLayout="fixed"
  [nzData]="dataList"

  [nzFrontPagination]="tableConfig.showFrontPagination"
  [nzSize]="tableConfig.size"
  [nzShowSizeChanger]="showSizeChanger"
  [nzPageSizeOptions]="pageSizeOptions"
  [nzTotal]="tableConfig!.total"


  [(nzPageIndex)]="tableConfig.pageIndex"
  (nzPageIndexChange)="onPageIndexChange($event)"
  [(nzPageSize)]="tableConfig.pageSize"
  (nzPageSizeChange)="onPageSizeChange($event)"

  (nzCurrentPageDataChange)="currentPageDataChange($event)"

  [nzShowQuickJumper]="showQuickJumper"
  [nzShowTotal]="rangeTotalTemplate ?? rangeTemplate"
  [nzWidthConfig]="nzWidthConfigTmp.length > 0? nzWidthConfigTmp: []"
  [nzLoading]="tableConfig.loading"
  [nzScroll]="tableConfig.needScroll ? isScrollHeight ? {x: nzScrollWidth + 'px',y: nzScrollHeight} : { x: nzScrollWidth + 'px',y:nzWidthConfig.length > 0? nzScrollHeight :'' } : {}"
  [nzOuterBordered]="true"
  [nzBordered]="bordered"
  [nzFooter]='tableConfig.footer'
>

  <thead>
  <tr *ngFor="let header of tableHeader">
    <ng-container *ngFor="let subHeader of header">

      <th
        *ngIf="subHeader.isCheckBox"
        [nzLeft]="true"
        [nzWidth]="subHeader.width && isScrollHeight ? subHeader.width + 'px' : ''"
        [ngClass]="['text-center']"
        [rowspan]="subHeader.rowspan ? subHeader.rowspan : 1"
        [ngStyle]="subHeader.width && !isScrollHeight ? {width: subHeader.width + 'px'} : {}"

        nzShowCheckbox="true"
        [nzChecked]="checkboxAllValueMap.get(currentPageIndex)"
        [nzIndeterminate]="checkboxAllIndeterminateMap.get(currentPageIndex)"
        (nzCheckedChange)="onAllChecked($event)"
      >
      </th>

      <th
        *ngIf="(subHeader.show === undefined || subHeader.show === true) && subHeader.remove !== true && !subHeader.isCheckBox"
        [rowspan]="subHeader.rowspan ? subHeader.rowspan : 1"
        [colSpan]="subHeader.colspan ? subHeader.colspan : 1"
        [nzRight]="(!!subHeader.fixed && subHeader.fixedDir==='right')"
        [nzLeft]="(!!subHeader.fixed && subHeader.fixedDir==='left')"

        [nzEllipsis]="subHeader.needEllipsis"
        [nzBreakWord]="subHeader.needBreakword"
        [nzWidth]="subHeader.width && isScrollHeight ? subHeader.width + 'px' : ''"
        [ngClass]="subHeader.thClassList ? subHeader.thClassList : ''"
        [ngStyle]="subHeader.width && !isScrollHeight ? {width: subHeader.width + 'px'} : {}"
      >

        <ng-container *ngIf="subHeader.thTemplate;else notTpl">
          <ng-container *ngTemplateOutlet="subHeader.thTemplate"></ng-container>
        </ng-container>

        <ng-template #notTpl>
          {{ subHeader.titleTrans }}
        </ng-template>

      </th>

    </ng-container>
  </tr>
  </thead>

  <tbody>
  <tr *ngFor="let row of dataList; index as rowIndex" (dblclick)="dblClick(row)" (click)="click(row)"
      [ngClass]="isShowSelectRow ? { 'activeRow': selectValue === row[conditionField]} : {}">
    <ng-container *ngFor="let head of tableHeaderMappingWithBe; index as headIndex">

      <td
        *ngIf="tableConfig.showSelect && headIndex === 0"
        [nzLeft]="true"
        [ngClass]="['text-center']"

        nzShowCheckbox="true"
        [nzChecked]="setOfCheckedId.has(row.id)"
        [nzDisabled]="row.disabled"
        (nzCheckedChange)="onItemChecked(row.id, $event)"
      >
      </td>

      <td
        *ngIf="(head.show === undefined || head.show === true) && head.remove !== true && (tableConfig.showSelect ? (tableConfig.showSelect && headIndex >= 1) : true)"
        [ngClass]="head.tdClassList ? head.tdClassList : '' "
        [nzEllipsis]="head.needEllipsis"
        [nzBreakWord]="head.needBreakword"
        [nzLeft]="(!!head.fixed && head.fixedDir==='left')"
        [nzRight]="(!!head.fixed && head.fixedDir==='right')"
      >
        <!--Nếu sử dụng td template custom -->
        <ng-container *ngIf="head.tdTemplate;else rowTpl">
          <ng-container *ngTemplateOutlet="head.tdTemplate;context:getRow(row, rowIndex)"></ng-container>
        </ng-container>
        <!--End: Nếu sử dụng td template custom -->

        <ng-template #rowTpl>
          <!--STT-->
          <ng-container *ngIf="head.titleTrans === 'STT' else notIndexCol">
            {{validateService.getRowIndex(rowIndex, tableConfig.pageIndex, tableConfig.pageSize)}}
          </ng-container>
          <!--End: STT-->
          <ng-template #notIndexCol>
              <ng-container *ngIf="head.pipe;else noPipe">
                <span [title]="(row|tableFiledPipe:head.field|map:head.pipe)">{{row|tableFiledPipe:head.field|map:head.pipe}}</span>
              </ng-container>
              <ng-template #noPipe>
                {{ row[head.field] }}
              </ng-template>
          </ng-template>
        </ng-template>
      </td>

    </ng-container>
  </tr>
  </tbody>

</nz-table>


<ng-template #rangeTemplate let-range="range" let-total>
  <div class="group__total--table" style="display: flex; align-items: center">
    <img style="margin-right: 5px" src="assets/icon/common/light.svg"
         alt=""> {{'common.paging.rangePage' | translate: { 'result': total } }} {{ range[0] }} - {{ range[1] }}
  </div>
</ng-template>
